Subject: Re: async network I/O, event channels, etc

From: Jens Axboe <[email-masked]>
Date: Thu, 27 Jul 2006 10:11:15 +0200

On Thu, Jul 27 2006, Jens Axboe wrote:
> On Thu, Jul 27 2006, David Miller wrote:
> > From: Evgeniy Polyakov <[email-masked]>
> > Date: Thu, 27 Jul 2006 11:49:02 +0400
> > 
> > > I.e. map skb's data to userspace? Not a good idea especially with it's
> > > tricky lifetime and unability for userspace to inform kernel when it
> > > finished and skb can be freed (without additional syscall).
> > 
> > Hmmm...
> > 
> > If it is paged based, I do not see the problem.  Events and calls to
> > AIO I/O routines make transfer of buffer ownership.  The fact that
> > while kernel (and thus networking stack) "owns" the buffer for an AIO
> > call, the user can have a valid mapping to it is a unimportant detail.
> 
> Ownership may be clear, but "when can I reuse" is tricky. The same issue
> comes up for vmsplice -> splice to socket.

Ownership transition from user -> kernel that is, what I'm trying to say
that returning ownership to the user again is the tricky part.

-- 
Jens Axboe